import './style.css'
import * as yup from "yup";
import { yupResolver} from "@hookform/resolvers/yup";
import { useForm } from "react-hook-form";
import { Link } from "react-router-dom";
import { useDispatch, useSelector } from "react-redux";
import { login } from "../../actions/auth/actoin";
import React, { useState } from "react";
import { Redirect } from "react-router-dom";

let schema = yup.object().shape({
    name: yup.string().required(),
    password: yup.string().required().min(6),
});

const Login=(props)=>{
    const { register, handleSubmit, errors } = useForm({
        resolver: yupResolver(schema)
    });
    const [loading, setLoading] = useState(false);
    const dispatch = useDispatch();
    const { isLoggedIn } = useSelector((state) => state.auth);
    const { message } = useSelector((state) => state.message);

    const onSubmit = (data) => {
        console.log(data)
        const{name,password}=data

        setLoading(true)
        if (name,password) {
            dispatch(login(name,password))
                .catch(() => {
                    setLoading(false)
                })
        } else {
            setLoading(false)
        }
    };
    if (isLoggedIn) {
        return <Redirect to="/posts/feed" />;
    } 

  return(
    <div className='auth'>
    <form onSubmit={handleSubmit(onSubmit)} className='auth2'>
        <h1 className='name'>Sign In</h1>
        <div>
            <input ref={register} name='name'className='inp' type='text' placeholder="Login"/>
        </div>
        <div>
            <input ref={register} name='password' className='inp' type='password' placeholder="Password"/>
        </div>
        <div>
            <button type='submit' className='but'>Sign in</button>
        </div>

                    <p className='text1'>If you not have account you can</p>
                    <Link className='link' to="/auth/registration"><h4>Registration</h4></Link>
    </form>
</div>
  )
            }
export default Login