import './style.css'
import { useForm } from "react-hook-form";
import * as yup from "yup";
import { yupResolver } from "@hookform/resolvers/yup";
import { Link } from "react-router-dom";
import React, { useState } from "react";
import { useDispatch, useSelector } from "react-redux";
import { registration } from "../../../src/actions/auth/actoin";

let schema = yup.object().shape({
    name: yup.string().required(),
    password: yup.string().required().min(6),
    email: yup.string().required("Please enter email").email(),
});

const Registration=(props)=>{
    const { register, handleSubmit, errors } = useForm({
        resolver: yupResolver(schema),
    });

    const [successful, setSuccessful] = useState(false);
    const dispatch = useDispatch();
    const { message } = useSelector((state) => state.message);

    const onSubmit = (data) => {
        console.log(data);
        const { name, email, password } = data;
        setSuccessful(false);
        if ((name, email, password)) {
            dispatch(registration(name, email, password))
                .catch(() => {
                    setSuccessful(false);
                });
        }
    };

    
      return(
        <div className='auth'>
        <form onSubmit={handleSubmit(onSubmit)} className='auth2'>
            <h2 className='name'>Sign Up</h2>
            <div>
                <input name='name' ref={register} className='inp' placeholder="Login" type='text'/>
            </div>
            <div>
                <input name='email' ref={register} className='inp' type='email'placeholder="Email"/>
            </div>
            <div>
                <input name='password' ref={register} className='inp' type='password' placeholder="Password" />
            </div>
            <div>
                <button type='submit' className='but'>Sign Up</button>
            </div>
        </form>
        <p className='text2'>If you have account you can</p>
        <Link className='link' to="/auth/login"><h4>Login</h4></Link>

    </div>
      )
            }

 export default Registration