import React, { Component, components } from "react";
import { userData } from "../data/users";

const sortTypes = {
	up: {
		class: 'sort-up',
		fn: (a, b) => a.age - b.age
	},
	down: {
		class: 'sort-down',
		fn: (a, b) => b.age - a.age
	},
	default: {
		class: 'sort',
		fn: (a, b) => a.index - b.index
	}
};

export class UsersFilter extends Component {
    constructor(props) {
        super(props);
        this.state = {
            userData: userData,
            search: "",
            currentSort: 'default'
        };
        this.handleSearch = this.handleSearch.bind(this);
    }

    handleSearch(event) {
        this.setState({ search: event.target.value });
    }

    onSortChange = () => {
		const { currentSort } = this.state;
		let nextSort;

        if (currentSort === 'default') nextSort = 'up';
        else if (currentSort === 'up') nextSort = 'down';
        else if (currentSort === 'down') nextSort = 'default'
        console.log(this.state)

		this.setState({
			currentSort: nextSort
		});
	};


    render() {
        const { currentSort } = this.state;
        const searchingName = (search) => {
            return function (x) {
                return (
                    x.name
                        .toLowerCase()
                        .includes(search.toLowerCase()) || !search
                );
            };
        };

        return (
            <div className="container">
                <div className="header">
                <button className='buton' onClick={this.onSortChange}>
									<p>Сортировка по возрасту</p>
								</button>
                    <input type="text" onChange={this.handleSearch} />
                </div>
                {this.state.userData
                    .sort(sortTypes[currentSort].fn)
                    .filter(searchingName(this.state.search))
                    .map((user) => {
                        return (
                            <div className="cart">
                                <img src={user.picture} width='100px' height='100px' />
                                <h2>{user.name}</h2>
                                <p>{user.age}</p>
                                <p>{user.gender}</p>
                                <h4>{user.balance}</h4>
                            </div>
                        );
                    })}
            </div>
        );
    }
}
