import logo from './logo.svg';
import './App.css';
import React from 'react'
import Info from './components/info'
import Form from './components/form'
import Weather from './components/weather'

const api = "77101dd26db53e77e9adbd29ddcac500"

class App extends React.Component {

  state = {
    temp: undefined,
    city: undefined,
    country: undefined,
    sunrise: undefined,
    sunset: undefined,
    error: undefined
  }

  gettingWeather = async (e) => {
    e.preventDefault()
    const city = e.target.elements.city.value

    if(city) {
    const api_url = await fetch(`https://api.openweathermap.org/data/2.5/weather?q=${city}&appid=${api}&units=metric`)
    const data = await api_url.json()

    let suri = data.sys.sunrise
    let ddate = new Date()
    ddate.setTime(suri)
    let suriDate = ddate.getHours() + ':' + ddate.getMinutes() + ":" + ddate.getSeconds()

    let suset = data.sys.sunset
    let date = new Date()
    date.setTime(suset)
    let susetDate = date.getHours() + ':' + date.getMinutes() + ":" + date.getSeconds()
    
    this.setState({
      temp: data.main.temp,
      city: data.name,
      country: data.sys.country,
      sunrise: suriDate,
      sunset: susetDate,
      error: undefined
    });
  } else {
    this.setState({
    temp: undefined,
    city: undefined,
    country: undefined,
    sunrise: undefined,
    sunset: undefined,
    error: 'Введите город!!!'
    })
  }
}

  render(){
    return(
      <div className='wrapper'>
        <div className="main">
          <div className="row">
            <div className='col-sm-5 info'><Info/>
            </div>
            <div className='col-sm-5 form'>
              <Form weatherMethod={this.gettingWeather}/>
        <Weather 
        temp={this.state.temp}
        city={this.state.city}
        country={this.state.country}
        sunrise={this.state.sunrise}
        sunset={this.state.sunset}
        error={this.state.error} />
        </div>
        </div>
        </div>
        </div>
    )
  }
}

export default App;
