import React, {useState} from 'react'
import AddUse from './forms/addUser'
import UserList from './tables/UseList'
import './App.css';
import SearchInput from './forms/Search'

let rand = Math.random()*10000000000000

const usersData = []
let localeArr = JSON.parse(localStorage.getItem("users"));
let chooseArr = localeArr == null ? usersData : localeArr;

const App = () => {

const [users, setusers] = useState(chooseArr)


const searchUser = (event) => {
  const { value } = event.target;
  let result = chooseArr.filter((user) => {
      return user.name
          .toLowerCase()
          .includes(value.toLowerCase());
  });
  setusers(result)
  console.log(result)
};

const addUser = user => {
  user.id = rand
  chooseArr.push(user)
  setusers([...chooseArr])
  localStorage.setItem("users", JSON.stringify([...chooseArr]));
  setusers(chooseArr);
}

const deleteUser = id => {
  localStorage.setItem("users", JSON.stringify(chooseArr.filter(user => user.id !== id)));
  setusers(chooseArr);
}


  return (
    <div className='container'>
      <div className='flexw'>
        <div className='flexAdd'>
          <h2>Add user</h2>
          <AddUse addUser={addUser}/>
        </div>
        <div className='flexList'>
          <h2>Users</h2>
          <SearchInput className="search" searchUser={searchUser} />
          <UserList users={users} deleteUser={deleteUser}/>
        </div>
      </div>
      <footer className='foot'>
      <h1 className='h11'>{'Количество пользователей: ' + users.length}</h1>
    </footer>
    </div>
  );
}

export default App;
