import React, {useState} from 'react'

const AddUse = props => {

    const formState = {id: null, name: '', surname: '', address:''}
    const [user, setUse] = useState(formState)

    const handleChange = e => {
        const {name, value} = e.currentTarget
        setUse({...user, [name]: value})
    }

    const handleSubmit = e => {
        e.preventDefault()
        if (!user.name || !user.surname) return 
        props.addUser(user)
        setUse(formState)
    }


    return (
        <form onSubmit={handleSubmit}>
            <label>Name</label>
            <input type='text' name='name' value={user.name} onChange={handleChange}/>
            <label>Surname</label>
            <input type='text' name='surname' value={user.surname} onChange={handleChange}/>
            <label>Address</label>
            <input type='text' name='address' value={user.address} onChange={handleChange}/>
            <button className='butAdd'>Add user</button>
        </form>
    )
}

export default AddUse